#encoding: utf-8

gem 'myerror'

module Ogem
  class Ship
    attr_reader :name, :r, :abv

    def initialize name="Ship", abv="", m=3000, c=1000, d=0
      if !name.is_a?String
        Error.call "Ogem::Ship::new : invalid name", Error::ERR_MEDIUM
        name = "UnknowShip"
      elsif !abv.is_a?String and !abv.is_a?Symbol
        Error.call "Ogem::Ship::new : invalid abv", Error::ERR_MEDIUM
        name = "unknow"
      end
      @name = name
      @abv = abv.to_sym
      @r = {m: m.to_i, c: c.to_i, d: d.to_i}
    end

    def how_many? r
      min = []
      min << r[:m] / @r[:m] if @r[:m] != 0
      min << r[:c] / @r[:c] if @r[:c] != 0
      min << r[:d] / @r[:d] if @r[:d] != 0
      return min.min.to_i
    end

    def cost
      line = ""
      Ogem::RESOURCES.each do |k, v|
        line += "\t<#{v}:#{@r[k]}>"
      end
      return line
    end

    def self.get_abv abv
      Ogem::SHIP_LIST.each do |k, ship|
        Error.call "Ship::self.get_abv : Invalid element #{ship}" if !ship.is_a?Ship
        return ship if ship.abv == abv
      end
      return nil
    end

  end
end
